<template>
  <st-content :heading="'Alumnos'">
    <st-back-btn />
    <st-updateStudent
      :key="componentKey"
      :data="{ ids, fields, nombreUnidad }"
      v-model="dialog"
      @refresh="refresh"
    />
    <div class="content-body">
      <div class="table-heading">
        <st-subtitle text="Datos generales" />
        <st-edit-btn @click="open" />
      </div>
      <v-row>
        <v-col md="6" v-for="(field,index) in fields" :key="index">
          <v-row align="center" no-gutters>
            <v-col md="4">
              <v-label>{{ field.label }}</v-label>
            </v-col>
            <v-col md="8">
              <v-label>{{ field.value }}</v-label>
            </v-col>
          </v-row>
        </v-col>
      </v-row>
      <v-row>
        <v-col md="6">
          <v-row align ="center" no-gutters>
          <v-col md="4">
            <v-label>Unidad</v-label>
          </v-col>
          <v-col md="8">
            <v-label>{{nombreUnidad}}</v-label>
          </v-col>
          </v-row>
        </v-col>
      </v-row>

    </div>

    <v-row class="my-4">
      <v-col>
        <div class="content-body">
          <div class="table-heading">
            <st-subtitle text="Información adicional" />
            <st-primary-btn :disable="disable" :loading="loading" nombre="Agregar" @click="addFile" />
          </div>
          <v-row>
            <v-col md="12" align-self="center">
              <v-file-input @change="archivo" label="Selecciona el archivo a subir" v-model="file" />
            </v-col>
          </v-row>
          <v-row v-if="files.length === 0">
            <v-col md="12" class="font-italic">No hay información adicional</v-col>
          </v-row>
          <v-row v-else>
            <v-col md="12">
              <v-data-table
                single-select
                :headers="headersInfo"
                :items="files"
                item-key="idSession"
                sort-by="calories"
                class="elevation-1"
                :hide-default-footer="files.length <= 10"
                loading-text="Cargando..."
                :loading="loading"
              >
                <template v-slot:item.fechaCreacion="{ item }">{{ item.fechaCreacion | formatDate }}</template>
                <template v-slot:item.actions="{ item }">
                  <v-icon medium color="primary" @click="download(item)">mdi-download</v-icon>
                  <v-icon medium color="primary"  @click="openDialog(item)">mdi-delete</v-icon>
                </template>
              </v-data-table>
            </v-col>
          </v-row>
        </div>
      </v-col>
    </v-row>
    <v-row justify="center">
    <v-dialog v-model="dialog2" persistent max-width="450">
      <v-card>
        <v-card-title class="headline">Eliminar archivo del alumno</v-card-title>
        <v-card-text class="my-2">¿Está seguro de eliminar el archivo? Recuerde que esto es un proceso irreversible.</v-card-text>
        <v-card-actions >
            <v-row no-gutters justify="end">
        <v-spacer></v-spacer> 
          <v-btn color="primary" text @click="dialog2 = false">Volver</v-btn>
          <v-btn color="secondary" :loading="loadDel" text @click="deleteFile">Eliminar</v-btn>
            </v-row>
        </v-card-actions>

      </v-card>
    </v-dialog>
  </v-row>
  </st-content>
</template>

<script>
import UpdateStudent from "@/components/student/UpdateStudent";
const toBase64 = file =>
  new Promise((resolve, reject) => {
    const reader = new FileReader();
    reader.readAsBinaryString(file);
    reader.onload = () => resolve(btoa(reader.result));
    reader.onerror = error => reject(error);
  });

export default {
  data() {
    return {
      disable : false,
      loading: false,
      loadDel: false,
      file: null,
      texto: "Agregar",
      subir: true,
      nombreUnidad: "",
      fields: {
        correo: { label: "Correo", value: "...Cargando" },
        codigo: { label: "Código", value: "...Cargando" },
        nombres: { label: "Nombres", value: "...Cargando" },
        apellidoPat: { label: "Apellido Paterno", value: "...Cargando" },
        apellidoMat: { label: "Apellido Materno", value: "...Cargando" },
        telefono: { label: "Teléfono", value: "...Cargando" }
      },
      files: [
        // { nombre: "Historico de notas", fechaCreacion: "2020-07-05T03:04:05.000Z" },
        // {
        //   nombre: "Carta de compromiso del alumno",
        //   fechaCreacion: "2020-07-05T03:04:05.000Z"
        // }
      ],
      componentKey: 0,
      dialog: false,
      dialog2 : false,
      item : null,
      ids: {},
      headersInfo: [
        {
          text: "Archivo",
          align: "start",
          sortable: false,
          value: "nombre"
        },
        { text: "Fecha de subida", value: "fechaCreacion" },
        {
          text: "Acciones",
          value: "actions",
          sortable: false,
          align: "center"
        }
      ]
    };
  },
  components: {
    "st-updateStudent": UpdateStudent
  },
  filters: {
    formatDate: function(value) {
      if (!value) return "Cargando...";
      let options = {
        year: "numeric",
        month: "long",
        day: "numeric",
        hour12: "true",
        timeStyle: "short",
        dateStyle: "long"
      };
      let d = new Date(value).toLocaleTimeString("es", options);
      return d;
    }
  },
  methods: {
    archivo(){
      this.disable = this.file == null
    },
    open() {
      this.dialog = true;
      this.componentKey += 1; //forceRerender
    },
    openDialog(item){
      this.dialog2 = true;
      this.item = item
    },
    refresh(value) {
      this.dialog = false;
      this.ini();
    },
    async ini() {
      this.loading = true;
      try {
        let {
          data: { data }
        } = await this.$api.getStudent(this.$route.params.id);

        this.fields.correo.value = data.correo;
        this.fields.codigo.value = data.codigo;
        this.fields.nombres.value = data.nombres;
        this.fields.apellidoPat.value = data.apellidoPat;
        this.fields.apellidoMat.value = data.apellidoMat;
        this.fields.telefono.value = data.telefono;
        let idStudent = data.idStudent;
        let idUsuario = data.idUsuario;
        let idUnidad = data.idUnidad;
        this.nombreUnidad=  data.nombreUnidad;

        this.ids = { idStudent, idUsuario, idUnidad};

        let response = await this.$api.getFileStudent(this.$route.params.id)
        this.files = response.data.data

      } catch (e) {
        this.$store.commit("setError", e);
      }
      this.loading = false;
    },
    download(item) {
      
       window.open(item.contenido, '_blank');
    },

    async addFile() {
      this.loading = true;
      let b64 = "";
      let name = this.file.name;
      try {
        b64 = await toBase64(this.file)
      } catch (error) {       
        this.$store.commit("setError", error);
      }
      // b64 = btoa(read.result)
      let data = {
        file: b64,
        nombre: name
      };


      try {
        let response = await this.$api.addFileStudent(
          this.$route.params.id,
          data
        );
        this.ini()
      } catch (e) {
        this.$store.commit("setError", e);
      }
      this.loading = false;
      this.file = [];
      this.disable = true
    },
    async deleteFile(){
      this.loadDel = true
      try {
        let response = await this.$api.deleteFileStudent(
          this.$route.params.id,
          this.item.idInfoAdicional
        );
        this.ini()
      } catch (e) {
        this.$store.commit("setError", e);
      }
      this.loadDel = false
      this.dialog2 = false
    }
  },
  mounted() {
    this.disable = this.file == null
    this.ini();
  }
};
</script>

<style scoped lang="scss">
/* scope for encapsulate css */
</style>
